## git-annex 6.20161118

=== Makefile ===
all=git-annex mans docs

# set to "./Setup" if you lack a cabal program. Or can be set to "stack"
BUILDER?=cabal
GHC?=ghc

PREFIX?=/usr
SHAREDIR?=share

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

build: $(all)

Build/SysConfig.hs: Build/TestConfig.hs Build/Configure.hs
	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
	if [ "$(BUILDER)" = stack ]; then \
		$(BUILDER) build $(BUILDEROPTIONS); \
	else \
		$(BUILDER) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
	fi

git-annex: Build/SysConfig.hs
	$(BUILDER) build $(BUILDEROPTIONS)
	if [ "$(BUILDER)" = stack ]; then \
		ln -sf $$(find .stack-work/ -name git-annex -type f | grep build/git-annex/git-annex | tail -n 1) git-annex; \
	else \
		ln -sf dist/build/git-annex/git-annex git-annex; \
	fi
	# Work around https://github.com/haskell/cabal/issues/3524
	# when not linked dynamically to haskell libs
	@if ! ldd git-annex | grep -q libHS; then \
		chrpath -d git-annex || echo "** unable to chrpath git-annex; it will be a little bit slower than necessary"; \
	fi

# These are not built normally.
git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
git-union-merge:
	$(GHC) --make -threaded $@

install-mans: mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
	install -m 0644 man/*.1 $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex/html/; \
	fi

install-bins: build
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell

install-misc: Build/InstallDesktopFile
	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
	install -d $(DESTDIR)$(PREFIX)/share/bash-completion/completions
	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/git-annex

install: install-bins install-docs install-misc

test: git-annex
	./git-annex test

retest: git-annex
	./git-annex test --rerun-update --rerun-filter failures

# hothasktags chokes on some template haskell etc, so ignore errors
tags:
	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -c --cpp -c -traditional -c --include=dist/build/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

mans: Build/MakeMans
	./Build/MakeMans

docs: mans
	LC_ALL=C TZ=UTC $(IKIWIKI) doc html -v --wikiname git-annex \
		--plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--plugin theme --set theme=actiontabs --set deterministic=1 \
		--disable-plugin=shortcut --disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='ikiwiki/*' \
		--exclude='news/.*' --exclude='design/assistant/blog/*' \
		--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*' \
		--exclude='users/*' --exclude='devblog/*' --exclude='thanks'

clean:
	if [ "$(BUILDER)" != ./Setup ] && [ "$(BUILDER)" != cabal ]; then $(BUILDER) clean; fi
	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
		doc/.ikiwiki html dist tags Build/SysConfig.hs \
		Setup Build/InstallDesktopFile Build/EvilSplicer \
		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
		Build/DistributionUpdate Build/BuildVersion Build/MakeMans \
		git-union-merge .tasty-rerun-log
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

Build/InstallDesktopFile: Build/InstallDesktopFile.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/EvilSplicer: Build/EvilSplicer.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/Standalone: Build/Standalone.hs Build/SysConfig.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/OSXMkLibs: Build/OSXMkLibs.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/LinuxMkLibs: Build/LinuxMkLibs.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/MakeMans: Build/MakeMans.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs

LINUXSTANDALONE_DEST=tmp/git-annex.linux
linuxstandalone:
	$(MAKE) git-annex linuxstandalone-nobuild
linuxstandalone-nobuild: Build/Standalone Build/LinuxMkLibs
	rm -rf "$(LINUXSTANDALONE_DEST)"
	mkdir -p tmp
	cp -R standalone/linux/skel "$(LINUXSTANDALONE_DEST)"
	sed -i -e 's/^GIT_ANNEX_PACKAGE_INSTALL=/GIT_ANNEX_PACKAGE_INSTALL=$(GIT_ANNEX_PACKAGE_INSTALL)/' "$(LINUXSTANDALONE_DEST)/runshell"
	
	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp git-annex "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE
	cp doc/logo_16x16.png doc/logo.svg $(LINUXSTANDALONE_DEST)
	cp standalone/trustedkeys.gpg $(LINUXSTANDALONE_DEST)

	./Build/Standalone "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
	install -d "$(LINUXSTANDALONE_DEST)/templates"
	install -d "$(LINUXSTANDALONE_DEST)/magic"
	cp /usr/share/file/magic.mgc "$(LINUXSTANDALONE_DEST)/magic"
	cp /usr/share/i18n -a "$(LINUXSTANDALONE_DEST)"
	
	./Build/LinuxMkLibs "$(LINUXSTANDALONE_DEST)"
	
	$(MAKE) install-mans DESTDIR="$(LINUXSTANDALONE_DEST)"

	cd tmp/git-annex.linux && find . -type f > git-annex.MANIFEST
	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
	cd tmp && tar c git-annex.linux | gzip -9 --rsyncable > git-annex-standalone-$(shell dpkg --print-architecture).tar.gz

# Run this target to build git-annex-standalone*.deb
debianstandalone: dpkg-buildpackage-F
# Run this target to build git-annex-standalone*.dsc
debianstandalone-dsc: dpkg-buildpackage-S

prep-standalone:
	$(MAKE) undo-standalone
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build quilt push -a
	debian/create-standalone-changelog

undo-standalone:
	test -e .git
	git checkout debian/changelog CHANGELOG
	quilt pop -a || true

commit-standalone:
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build  quilt refresh

dpkg-buildpackage%: prep-standalone
	umask 022; dpkg-buildpackage -rfakeroot $*
	$(MAKE) undo-standalone

OSXAPP_DEST=tmp/build-dmg/git-annex.app
OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
osxapp: Build/Standalone Build/OSXMkLibs
	$(MAKE) git-annex

	# Remove all RPATHs, both because this overloads the linker on
	# OSX Sierra, and to avoid the binary looking in someone's home
	# directory.
	eval install_name_tool $$(otool -l git-annex | grep "path " | sed 's/.*path /-delete_rpath /' | sed 's/ (.*//') git-annex

	rm -rf "$(OSXAPP_DEST)" "$(OSXAPP_BASE)"
	install -d tmp/build-dmg
	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"

	install -d "$(OSXAPP_BASE)"
	cp git-annex "$(OSXAPP_BASE)"
	strip "$(OSXAPP_BASE)/git-annex"
	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt
	cp standalone/trustedkeys.gpg $(OSXAPP_DEST)/Contents/MacOS

	./Build/Standalone $(OSXAPP_BASE)

	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
	install -d "$(OSXAPP_BASE)/templates"
	install -d "$(OSXAPP_BASE)/magic"
	if [ -e "$(OSX_MAGIC_FILE)" ]; then \
		cp "$(OSX_MAGIC_FILE)" "$(OSXAPP_BASE)/magic/magic.mgc"; \
	else \
		echo "** OSX_MAGIC_FILE not set; not including it" >&2; \
	fi

	# OSX looks in man dir nearby the bin
	$(MAKE) install-mans DESTDIR="$(OSXAPP_BASE)/.." SHAREDIR="" PREFIX=""

	./Build/OSXMkLibs $(OSXAPP_BASE)
	cd $(OSXAPP_DEST) && find . -type f > Contents/MacOS/git-annex.MANIFEST
	cd $(OSXAPP_DEST) && find . -type l >> Contents/MacOS/git-annex.MANIFEST
	rm -f tmp/git-annex.dmg
	hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
		-volname git-annex -o tmp/git-annex.dmg

ANDROID_FLAGS?=
# Cross compile for Android.
# Uses https://github.com/neurocyte/ghc-android
android: Build/EvilSplicer
	echo "Running native build, to get TH splices.."
	if [ ! -e dist/setup/setup ]; then $(BUILDER) configure -O0 $(ANDROID_FLAGS) -fAndroidSplice;  fi
	mkdir -p tmp
	if ! $(BUILDER) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
	echo "Setting up Android build tree.."
	./Build/EvilSplicer tmp/splices tmp/dump-splices standalone/no-th/evilsplicer-headers.hs
	rsync -az --exclude tmp --exclude dist . tmp/androidtree
# Copy the files with expanded splices to the source tree, but
# only if the existing source file is not newer. (So, if a file
# used to have TH splices but they were removed, it will be newer,
# and not overwritten.)
	cp -uR tmp/splices/* tmp/androidtree || true
# Some additional dependencies needed by the expanded splices.
	sed -i 's/^  Build-Depends: */  Build-Depends: yesod-core, yesod-routes, shakespeare, blaze-markup, file-embed, wai-app-static, wai, unordered-containers, /' tmp/androidtree/git-annex.cabal
# Avoid warnings due to sometimes unused imports added for the splices.
	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
	sed -i 's/Extensions: /Extensions: MagicHash /i' tmp/androidtree/git-annex.cabal
# Cabal cannot cross compile with custom build type, so workaround.
	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
# Build just once, but link repeatedly, for different versions of Android.
	mkdir -p tmp/androidtree/dist/build/git-annex/4.0 tmp/androidtree/dist/build/git-annex/4.3 tmp/androidtree/dist/build/git-annex/5.0
	if [ ! -e tmp/androidtree/dist/setup-config ]; then \
		cd tmp/androidtree && CROSS_COMPILE=Android $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal configure -fAndroid $(ANDROID_FLAGS); \
	fi
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.0/git-annex
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.3/git-annex
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc --ghc-options=-optl-fPIE --ghc-options=-optl-pie --ghc-options=-optc-fPIE --ghc-options=-optc-pie \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/5.0/git-annex

androidapp:
	$(MAKE) android
	$(MAKE) -C standalone/android

# Bypass cabal, and only run the main ghc --make command for a
# faster development build.
fast: dist/cabalbuild
	@sh dist/cabalbuild
	@ln -sf dist/build/git-annex/git-annex git-annex
	@$(MAKE) tags >/dev/null 2>&1 &

dist/cabalbuild: dist/caballog
	grep 'ghc --make' dist/caballog | tail -n 1 > dist/cabalbuild
	
dist/caballog: git-annex.cabal
	$(BUILDER) configure -f"-Production" -O0 --enable-executable-dynamic
	$(BUILDER) build -v2 --ghc-options="-O0 -j" | tee dist/caballog

# Hardcoded command line to make hdevtools start up and work.
# You will need some memory. It's worth it.
# Note: Don't include WebDAV or Webapp. TH use bloats memory > 500 mb!
# TODO should be possible to derive this from caballog.
hdevtools:
	hdevtools --stop-server || true

=== debian/changelog ===
git-annex (6.20161118-1) unstable; urgency=medium

  * Package 6.20161118-1

 -- Richard Hartmann <richih@debian.org>  Fri, 18 Nov 2016 17:37:25 +0100

git-annex (6.20161118) unstable; urgency=medium

  * git-annex.cabal: Loosen bounds on persistent to allow 2.5, which
    on Debian has been patched to work with esqueleto.
    This may break cabal's resolver on non-Debian systems;
    if so, either use stack to build, or run cabal with 
    --constraint='persistent ==2.2.4.1'
    Hopefully this mess with esqueleto will be resolved soon.
  * sync: Pass --allow-unrelated-histories to git merge when used with git
    git 2.9.0 or newer. This makes merging a remote into a freshly created
    direct mode repository work the same as it works in indirect mode.
  * Avoid backtraces on expected failures when built with ghc 8;
    only use backtraces for unexpected errors.
  * fsck --all --from was checking the existence and content of files
    in the local repository, rather than on the special remote. Oops.
  * Linux arm standalone: Build with a 32kb page size, which is needed
    on several ARM NAS devices, including Drobo 5N, and WD NAS.

 -- Joey Hess <id@joeyh.name>  Fri, 18 Nov 2016 11:43:14 -0400

git-annex (6.20161111-1) unstable; urgency=medium

  * Package 6.20161111-1

 -- Richard Hartmann <richih@debian.org>  Wed, 16 Nov 2016 19:39:39 +0100

git-annex (6.20161111) unstable; urgency=medium

  * Restarting a crashing git process could result in filename encoding
    issues when not in a unicode locale, as the restarted processes's
    handles were not read in raw mode.
  * Make .git/annex/ssh.config file work with versions of ssh older than
    7.3, which don't support Include. When used with an older version
    of ssh, any ServerAliveInterval in ~/.ssh/config will be overridden
    by .git/annex/ssh.config.
  * S3: Support the special case endpoint needed for the cn-north-1 region.
  * Webapp: Don't list the Frankfurt S3 region, as this (and some other new
    regions) need V4 authorization which the aws library does not yet use.
  * reinject --known: Avoid second, unncessary checksum of file.
  * OSX: Remove RPATHs from git-annex binary, which are not needed,
    slow down startup, and break the OSX Sierra linker.
  * webapp: Explicitly avoid checking for auth in static subsite
    requests. Yesod didn't used to do auth checks for that, but this may
    have changed.
  * Linux standalone: Avoid using hard links in the tarball so it can be
    untarred on eg, afs which does not support them.

 -- Joey Hess <id@joeyh.name>  Fri, 11 Nov 2016 14:46:39 -0400

git-annex (6.20161031-1) unstable; urgency=medium

  * Package 6.20161031-1
  * Update cabal dependency on persistent Closes: #842572

 -- Richard Hartmann <richih@debian.org>  Sun, 06 Nov 2016 19:22:02 +0100

git-annex (6.20161031) unstable; urgency=medium

  * Assistant, repair: Fix ignoring of git fsck errors due to
    duplicate file entries in tree objects.
  * Linux standalone: Fix location of locale files in the bundle.
  * Fix reversion in 6.20161012 that prevented adding files with a space
    in their name.

 -- Joey Hess <id@joeyh.name>  Mon, 31 Oct 2016 18:55:59 -0400

git-annex (6.20161027-1) unstable; urgency=medium

  * Package 6.20161027-1

 -- Richard Hartmann <richih@debian.org>  Thu, 27 Oct 2016 21:53:55 +0200

git-annex (6.20161027) unstable; urgency=medium

  * lock, smudge: Fix edge cases where data loss could occur in v6 mode
    when the keys database was not populated.
  * upgrade: Handle upgrade to v6 when the repository already contains
    v6 unlocked files whose content is already present.
  * Improve style of offline html build of website.
  * importfeed: Drop URL parameters from file extension.
    Thanks, James MacMahon.
  * Assistant, repair: Improved filtering out of git fsck lines about
    duplicate file entries in tree objects.
  * test: Deal with gpg-agent behavior change that broke the test suite.
  * Improve ssh socket cleanup code to skip over the cruft that
    NFS sometimes puts in a directory when a file is being deleted.
  * If a transfer fails for some reason, but some data managed to be sent,
    the transfer will be retried. (The assistant already did this.)
  * Run ssh with ServerAliveInterval 60, so that stalled transfers will
    be noticed within about 3 minutes.
    (Any setting in your ~/.ssh/config or /etc/ssh/ssh_config 
    overrides this.)

 -- Joey Hess <id@joeyh.name>  Thu, 27 Oct 2016 15:21:58 -0400

## git-annex 6.20161210

=== Makefile ===
--- 
+++ 
@@ -55,6 +55,7 @@
 	install -d $(DESTDIR)$(PREFIX)/bin
 	install git-annex $(DESTDIR)$(PREFIX)/bin
 	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
+	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-remote-tor-annex
 
 install-misc: Build/InstallDesktopFile
 	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
@@ -133,6 +134,7 @@
 	cp git-annex "$(LINUXSTANDALONE_DEST)/bin/"
 	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
 	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
+	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-remote-tor-annex"
 	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE
 	cp doc/logo_16x16.png doc/logo.svg $(LINUXSTANDALONE_DEST)
 	cp standalone/trustedkeys.gpg $(LINUXSTANDALONE_DEST)
@@ -194,6 +196,7 @@
 	cp git-annex "$(OSXAPP_BASE)"
 	strip "$(OSXAPP_BASE)/git-annex"
 	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
+	ln -sf git-annex "$(OSXAPP_BASE)/git-remote-tor-annex"
 	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
 	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt
 	cp standalone/trustedkeys.gpg $(OSXAPP_DEST)/Contents/MacOS

=== debian/changelog ===
git-annex (6.20161210-1) unstable; urgency=medium

  * Package 6.20161210-1

 -- Richard Hartmann <richih@debian.org>  Sat, 10 Dec 2016 20:18:21 +0100

git-annex (6.20161210) unstable; urgency=medium

  * enable-tor: New command, enables tor hidden service for P2P syncing.
  * p2p: New command, allows linking repositories using a P2P network.
  * remotedaemon: Serve tor hidden service.
  * Added git-remote-tor-annex, which allows git pull and push to the tor
    hidden service.
  * remotedaemon: Fork to background by default. Added --foreground switch
    to enable old behavior.
  * addurl: Fix bug in checking annex.largefiles expressions using
    largerthan, mimetype, and smallerthan; the first two always failed
    to match, and the latter always matched.
  * Relicense 5 source files that are not part of the webapp from AGPL to GPL.
  * map: Run xdot if it's available in PATH. On OSX, the dot command
    does not support graphical display, while xdot does.
  * Debian: xdot is a better interactive viewer than dot, so Suggest
    xdot, rather than graphviz.
  * rmurl: Multiple pairs of files and urls can be provided on the
    command line.
  * rmurl: Added --batch mode.
  * fromkey: Accept multiple pairs of files and keys.
    Thanks, Daniel Brooks.
  * rekey: Added --batch mode.
  * add: Stage modified non-large files when running in indirect mode. 
    (This was already done in v6 mode and direct mode.)
  * git-annex-shell, remotedaemon, git remote: Fix some memory DOS attacks.
  * Fix build with http-client 0.5.
    Thanks, Alper Nebi Yasak.

 -- Joey Hess <id@joeyh.name>  Sat, 10 Dec 2016 11:56:25 -0400

=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 7.4),
	cabal-install,
	libghc-mtl-dev (>= 2.1.1),
	libghc-missingh-dev,
	libghc-data-default-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-cryptonite-dev | libghc-cryptohash-dev (>= 0.11.0),
	libghc-sandi-dev,
	libghc-utf8-string-dev,
	libghc-aws-dev (>= 0.9.2-2~),
	libghc-conduit-dev,
	libghc-resourcet-dev,
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-transformers-dev,
	libghc-exceptions-dev (>= 0.6),
	libghc-unix-compat-dev,
	libghc-dlist-dev,
	libghc-uuid-dev,
	libghc-aeson-dev,
	libghc-unordered-containers-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-hinotify-dev [linux-any],
	libghc-stm-dev (>= 2.3),
	libghc-dbus-dev (>= 0.10.7) [linux-any],
	libghc-fdo-notify-dev (>= 0.3) [linux-any],
	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armhf kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-default-dev (>= 1.2.0) [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-clientsession-dev            [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-warp-dev (>= 3.0.0.5)        [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-warp-tls-dev                 [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-wai-dev                      [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-wai-extra-dev                [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-dav-dev (>= 1.0),
	libghc-persistent-dev,
	libghc-persistent-template-dev,
	libghc-persistent-sqlite-dev,
	libghc-esqueleto-dev,
	libghc-securemem-dev,
	libghc-byteable-dev,
	libghc-stm-chans-dev,
	libghc-dns-dev,
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-http-conduit-dev,
	libghc-blaze-builder-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev [linux-any kfreebsd-any],
	libghc-safesemaphore-dev,
	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
	libghc-gnutls-dev (>= 0.1.4),
	libghc-xml-types-dev,
	libghc-async-dev,
	libghc-monad-logger-dev,
	libghc-free-dev,
	libghc-feed-dev (>= 0.3.9.2),
	libghc-regex-tdfa-dev,
	libghc-tasty-dev (>= 0.7),
	libghc-tasty-hunit-dev,
	libghc-tasty-quickcheck-dev,
	libghc-tasty-rerun-dev,
	libghc-optparse-applicative-dev (>= 0.11.0),
	libghc-cabal-dev,
	libghc-torrent-dev,
	libghc-concurrent-output-dev,
	libghc-disk-free-space-dev,
	libghc-mountpoints-dev,
	libghc-magic-dev,
	libghc-socks-dev,
	lsof [linux-any],
	ikiwiki,
	libimage-magick-perl,
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client,
	git-remote-gcrypt (>= 0.20130908-6),
	chrpath,
Maintainer: Richard Hartmann <richih@debian.org>
Standards-Version: 3.9.8
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/
XS-Testsuite: autopkgtest

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client (>= 1:5.6p1)
Recommends: 
	lsof,
	gnupg,
	bind9-host,
	quvi,
	git-remote-gcrypt (>= 0.20130908-6),
	nocache,
	aria2,
Suggests:
	xdot,
	bup,
	tahoe-lafs,
	libnss-mdns,
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 It can store large files in many places, from local hard drives, to a
 large number of cloud storage services, including S3, WebDAV,
 and rsync, with a dozen cloud storage providers usable via plugins.
 Files can be stored encrypted with gpg, so that the cloud storage
 provider cannot see your data. git-annex keeps track of where each file
 is stored, so it knows how many copies are available, and has many
 facilities to ensure your data is preserved.
 .
 git-annex can also be used to keep a folder in sync between computers,
 noticing when files are changed, and automatically committing them
 to git and transferring them to other computers. The git-annex webapp
 makes it easy to set up and use git-annex this way.

## git-annex 6.20170101

=== debian/changelog ===
git-annex (6.20170101-1+deb9u2) stretch; urgency=high

  [ Joey Hess ]
  * CVE-2018-10857:
    - Added annex.security.allowed-url-schemes setting, which defaults
      to only allowing http, https, and ftp URLs. Note especially that file:/
      is no longer enabled by default.
    - Removed annex.web-download-command, since its interface does not allow
      supporting annex.security.allowed-url-schemes across redirects.
      If you used this setting, you may want to instead use annex.web-options
      to pass options to curl.
    - git-annex will refuse to download content from the web, to prevent
      accidental exposure of data on private webservers on localhost and the
      LAN. This can be overridden with the
      annex.security.allowed-http-addresses setting.
      (The S3, glacier, and webdav special remotes are still allowed to
      download from the web.)
  * CVE-2018-10857 and CVE-2018-10859:
    - Refuse to download content, that cannot be verified with a hash,
      from encrypted special remotes (for CVE-2018-10859),
      and from all external special remotes (for CVE-2018-10857).
      In particular, URL and WORM keys stored on such remotes won't
      be downloaded. If this affects your files, you can run
      `git-annex migrate` on the affected files, to convert them
      to use a hash.
    - Added annex.security.allow-unverified-downloads, which can override
      the above.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 22 Jun 2018 16:42:37 +0100

git-annex (6.20170101-1+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * CVE-2017-12976: git-annex before 6.20170818 allows remote attackers to
    execute arbitrary commands via an ssh URL with an initial dash
    character in the hostname, as demonstrated by an ssh://-eProxyCommand=
    URL (Closes: #873088)

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 26 Oct 2017 10:28:29 -0400

git-annex (6.20170101-1) unstable; urgency=medium

  * Package 6.20170101-1

 -- Richard Hartmann <richih@debian.org>  Fri, 06 Jan 2017 14:48:34 +0100

git-annex (6.20170101) unstable; urgency=medium

  * XMPP support has been removed from the assistant in this release.
    If your repositories used XMPP to keep in sync, that will no longer
    work, and you should enable some other remote to keep them in sync.
    A ssh server is one way, or use the new Tor pairing feature.
  * p2p --pair makes it easy to pair repositories, over Tor, using
    Magic Wormhole codes to find the other repository.
    See http://git-annex.branchable.com/tips/peer_to_peer_network_with_tor/
  * webapp: The "Share with a friend" and "Share with your other devices"
    pages have been changed to pair repositories using Tor and Magic Wormhole.
  * metadata --batch: Fix bug when conflicting metadata changes were
    made in the same batch run.
  * Pass annex.web-options to wget and curl after other options, so that
    eg --no-show-progress can be set by the user to disable the default
    --show-progress.
  * Revert ServerAliveInterval change in 6.20161111, which caused problems
    with too many old versions of ssh and unusual ssh configurations.
    It should have not been needed anyway since ssh is supposted to
    have TCPKeepAlive enabled by default.
  * Make all --batch input, as well as fromkey and registerurl stdin
    be processed without requiring it to be in the current encoding.
  * p2p: --link no longer takes a remote name, instead the --name
    option can be used.
  * Linux standalone: Improve generation of locale definition files,
    supporting locales such as en_GB.UTF-8.
  * rekey --force: Incorrectly marked the new key's content as being
    present in the local repo even when it was not.
  * enable-tor: Put tor sockets in /var/lib/tor-annex/, rather
    than in /etc/tor/hidden_service/.
  * enable-tor: No longer needs to be run as root.
  * enable-tor: When run as a regular user, also tests a connection back to 
    the hidden service over tor.
  * Support all common locations of the torrc file.
  * Always use filesystem encoding for all file and handle reads and
    writes.
  * Fix build with directory-1.3.
  * Debian: Suggest tor and magic-wormhole.
  * Debian: Build webapp on armel.

 -- Joey Hess <id@joeyh.name>  Sat, 31 Dec 2016 15:11:04 -0400

=== debian/control ===
--- 
+++ 
@@ -32,17 +32,17 @@
 	libghc-stm-dev (>= 2.3),
 	libghc-dbus-dev (>= 0.10.7) [linux-any],
 	libghc-fdo-notify-dev (>= 0.3) [linux-any],
-	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armhf kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-yesod-default-dev (>= 1.2.0) [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-clientsession-dev            [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-warp-dev (>= 3.0.0.5)        [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-warp-tls-dev                 [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-wai-dev                      [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-wai-extra-dev                [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-yesod-default-dev (>= 1.2.0) [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-clientsession-dev            [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-warp-dev (>= 3.0.0.5)        [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-warp-tls-dev                 [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-wai-dev                      [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-wai-extra-dev                [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
 	libghc-dav-dev (>= 1.0),
 	libghc-persistent-dev,
 	libghc-persistent-template-dev,
@@ -60,9 +60,6 @@
 	libghc-network-multicast-dev,
 	libghc-network-info-dev [linux-any kfreebsd-any],
 	libghc-safesemaphore-dev,
-	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
-	libghc-gnutls-dev (>= 0.1.4),
-	libghc-xml-types-dev,
 	libghc-async-dev,
 	libghc-monad-logger-dev,
 	libghc-free-dev,
@@ -116,6 +113,8 @@
 Suggests:
 	xdot,
 	bup,
+	tor,
+	magic-wormhole,
 	tahoe-lafs,
 	libnss-mdns,
 Description: manage files with git, without checking their contents into git

## git-annex 6.20170818

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-all=git-annex mans docs
+all=git-annex git-annex-shell mans docs
 
 # set to "./Setup" if you lack a cabal program. Or can be set to "stack"
 BUILDER?=cabal
@@ -14,26 +14,31 @@
 
 build: $(all)
 
-Build/SysConfig.hs: Build/TestConfig.hs Build/Configure.hs
+tmp/configure-stamp: Build/TestConfig.hs Build/Configure.hs
 	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
-	if [ "$(BUILDER)" = stack ]; then \
-		$(BUILDER) build $(BUILDEROPTIONS); \
+	if [ "$(BUILDER)" != stack ]; then \
+		$(BUILDER) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
 	else \
-		$(BUILDER) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
-	fi
-
-git-annex: Build/SysConfig.hs
+		$(BUILDER) setup; \
+	fi
+	mkdir -p tmp
+	touch tmp/configure-stamp
+
+git-annex: tmp/configure-stamp
 	$(BUILDER) build $(BUILDEROPTIONS)
 	if [ "$(BUILDER)" = stack ]; then \
-		ln -sf $$(find .stack-work/ -name git-annex -type f | grep build/git-annex/git-annex | tail -n 1) git-annex; \
+		ln -sf $$(stack path --dist-dir)/build/git-annex/git-annex git-annex; \
 	else \
 		ln -sf dist/build/git-annex/git-annex git-annex; \
 	fi
-	# Work around https://github.com/haskell/cabal/issues/3524
-	# when not linked dynamically to haskell libs
+# Work around https://github.com/haskell/cabal/issues/3524
+# when not linked dynamically to haskell libs
 	@if ! ldd git-annex | grep -q libHS; then \
 		chrpath -d git-annex || echo "** unable to chrpath git-annex; it will be a little bit slower than necessary"; \
 	fi
+
+git-annex-shell: git-annex
+	ln -sf git-annex git-annex-shell
 
 # These are not built normally.
 git-union-merge.1: doc/git-union-merge.mdwn
@@ -57,14 +62,20 @@
 	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
 	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-remote-tor-annex
 
-install-misc: Build/InstallDesktopFile
+install-misc: build Build/InstallDesktopFile
 	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
-	install -d $(DESTDIR)$(PREFIX)/share/bash-completion/completions
-	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/git-annex
+	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/bash-completion/completions
+	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/$(SHAREDIR)/bash-completion/completions/git-annex
+	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/zsh/vendor-completions
+	@./git-annex --zsh-completion-script git-annex > $(DESTDIR)$(PREFIX)/$(SHAREDIR)/zsh/vendor-completions/_git-annex || \
+		echo "** zsh completions not installed; built with too old version of optparse-applicative"
+	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions
+	@./git-annex --fish-completion-script git-annex > $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions/git-annex.fish || \
+		echo "** fish completions not installed; built with too old version of optparse-applicative"
 
 install: install-bins install-docs install-misc
 
-test: git-annex
+test: git-annex git-annex-shell
 	./git-annex test
 
 retest: git-annex
@@ -104,7 +115,7 @@
 		Setup Build/InstallDesktopFile Build/EvilSplicer \
 		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
 		Build/DistributionUpdate Build/BuildVersion Build/MakeMans \
-		git-union-merge .tasty-rerun-log
+		git-annex-shell git-union-merge .tasty-rerun-log
 	find . -name \*.o -exec rm {} \;
 	find . -name \*.hi -exec rm {} \;
 
@@ -112,7 +123,7 @@
 	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/EvilSplicer: Build/EvilSplicer.hs
 	$(GHC) --make $@ -Wall -fno-warn-tabs
-Build/Standalone: Build/Standalone.hs Build/SysConfig.hs
+Build/Standalone: Build/Standalone.hs tmp/configure-stamp
 	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/OSXMkLibs: Build/OSXMkLibs.hs
 	$(GHC) --make $@ -Wall -fno-warn-tabs
@@ -122,9 +133,8 @@
 	$(GHC) --make $@ -Wall -fno-warn-tabs
 
 LINUXSTANDALONE_DEST=tmp/git-annex.linux
-linuxstandalone:
-	$(MAKE) git-annex linuxstandalone-nobuild
-linuxstandalone-nobuild: Build/Standalone Build/LinuxMkLibs
+linuxstandalone: 
+	$(MAKE) git-annex Build/Standalone Build/LinuxMkLibs
 	rm -rf "$(LINUXSTANDALONE_DEST)"
 	mkdir -p tmp
 	cp -R standalone/linux/skel "$(LINUXSTANDALONE_DEST)"
@@ -144,6 +154,7 @@
 	install -d "$(LINUXSTANDALONE_DEST)/git-core"
 	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
 	install -d "$(LINUXSTANDALONE_DEST)/templates"
+	(cd "$(shell git --man-path)"/../git-core/templates && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/templates && tar x)
 	install -d "$(LINUXSTANDALONE_DEST)/magic"
 	cp /usr/share/file/magic.mgc "$(LINUXSTANDALONE_DEST)/magic"
 	cp /usr/share/i18n -a "$(LINUXSTANDALONE_DEST)"
@@ -180,13 +191,15 @@
 
 OSXAPP_DEST=tmp/build-dmg/git-annex.app
 OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
-osxapp: Build/Standalone Build/OSXMkLibs
-	$(MAKE) git-annex
+osxapp:
+	$(MAKE) git-annex Build/Standalone Build/OSXMkLibs
 
 	# Remove all RPATHs, both because this overloads the linker on
 	# OSX Sierra, and to avoid the binary looking in someone's home
 	# directory.
-	eval install_name_tool $$(otool -l git-annex | grep "path " | sed 's/.*path /-delete_rpath /' | sed 's/ (.*//') git-annex
+	if otool -l git-annex | grep -q "path "; then \
+		eval install_name_tool $$(otool -l git-annex | grep "path " | sed 's/.*path /-delete_rpath /' | sed 's/ (.*//') git-annex; \
+	fi
 
 	rm -rf "$(OSXAPP_DEST)" "$(OSXAPP_BASE)"
 	install -d tmp/build-dmg
@@ -205,6 +218,7 @@
 
 	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
 	install -d "$(OSXAPP_BASE)/templates"
+	(cd "$(shell git --man-path)"/../git-core/templates && tar c .) | (cd "$(OSXAPP_BASE)"/templates && tar x)
 	install -d "$(OSXAPP_BASE)/magic"
 	if [ -e "$(OSX_MAGIC_FILE)" ]; then \
 		cp "$(OSX_MAGIC_FILE)" "$(OSXAPP_BASE)/magic/magic.mgc"; \
@@ -261,25 +275,3 @@
 
 androidapp:
 	$(MAKE) android
-	$(MAKE) -C standalone/android
-
-# Bypass cabal, and only run the main ghc --make command for a
-# faster development build.
-fast: dist/cabalbuild
-	@sh dist/cabalbuild
-	@ln -sf dist/build/git-annex/git-annex git-annex
-	@$(MAKE) tags >/dev/null 2>&1 &
-
-dist/cabalbuild: dist/caballog
-	grep 'ghc --make' dist/caballog | tail -n 1 > dist/cabalbuild
-	
-dist/caballog: git-annex.cabal
-	$(BUILDER) configure -f"-Production" -O0 --enable-executable-dynamic
-	$(BUILDER) build -v2 --ghc-options="-O0 -j" | tee dist/caballog
-
-# Hardcoded command line to make hdevtools start up and work.
-# You will need some memory. It's worth it.
-# Note: Don't include WebDAV or Webapp. TH use bloats memory > 500 mb!
-# TODO should be possible to derive this from caballog.
-hdevtools:
-	hdevtools --stop-server || true

=== debian/changelog ===
git-annex (6.20170818-1) unstable; urgency=high

  * Package 6.20170818-1

 -- Richard Hartmann <richih@debian.org>  Sun, 20 Aug 2017 12:25:57 +0200

git-annex (6.20170818) unstable; urgency=high

  * Security fix: Disallow hostname starting with a dash, which
    would get passed to ssh and be treated an option. This could
    be used by an attacker who provides a crafted repository url
    to cause the victim to execute arbitrary code via -oProxyCommand.
    (The same class of security hole recently affected git itself.)
  * git-annex.cabal: Deal with breaking changes in Cabal 2.0.
  * Fix build with QuickCheck 2.10.
  * fsck: Support --json.
  * move, copy: Support --batch.
  * Added GIT_ANNEX_VECTOR_CLOCK environment variable, which can be used to
    override the default timestamps used in log files in the git-annex
    branch. This is a dangerous environment variable; use with caution.
  * Fix a git-annex test failure when run on NFS due to NFS lock files
    preventing directory removal.
  * test: Avoid most situations involving failure to delete test
    directories, by forking a worker process and only deleting the test
    directory once it exits.
  * Disable http-client's default 30 second response timeout when HEADing
    an url to check if it exists. Some web servers take quite a long time
    to answer a HEAD request.
  * Added remote configuration settings annex-ignore-command and
    annex-sync-command, which are dynamic equivilants of the annex-ignore
    and annex-sync configurations.
  * Prevent spaces from being embedded in the name of new WORM keys,
    as that handing spaces in keys would complicate things like the
    external special remote protocol.
  * migrate: WORM keys containing spaces will be migrated to not contain
    spaces anymore.
  * External special remotes will refuse to operate on keys with spaces in
    their names. That has never worked correctly due to the design of the
    external special remote protocol. Display an error message suggesting
    migration.
  * Fix incorrect external special remote documentation, which said that
    the filename parameter to the TRANSFER command could not contain
    spaces. It can in fact contain spaces. Special remotes implementors
    that relied on that may need to fix bugs in their special remotes.
  * Fix the external special remotes git-annex-remote-ipfs, 
    git-annex-remote-torrent and the example.sh template to correctly
    support filenames with spaces.
  * Windows: Win32 package has subsumed Win32-extras; update dependency.

 -- Joey Hess <id@joeyh.name>  Fri, 18 Aug 2017 11:19:06 -0400

git-annex (6.20170520) unstable; urgency=medium

  * move --to=here moves from all reachable remotes to the local repository.
  * initremote, enableremote: Support gpg subkeys suffixed with an
    exclamation mark, which forces gpg to use a specific subkey.
  * Improve progress display when watching file size, in cases where
    a transfer does not resume.
  * Fix transfer log file locking problem when running concurrent
    transfers.
  * Avoid concurrent git-config setting problem when running concurrent
    threads.
  * metadata: When setting metadata of a file that did not exist,
    no error message was displayed, unlike getting metadata and most other
    git-annex commands. Fixed this oversight.
  * Added annex.resolvemerge configuration, which can be set to false to 
    disable the usual automatic merge conflict resolution done by git-annex
    sync and the assistant.
  * sync: Added --no-resolvemerge option.
  * Avoid error about git-annex-shell not being found when
    syncing with -J with a git remote where git-annex-shell is not
    installed.
  * Fix bug that prevented transfer locks from working when
    run on SMB or other filesystem that does not support fcntl locks
    and hard links.
  * assistant: Merge changes from refs/remotes/foo/master into master.
    Previously, only sync branches were merged. This makes regular git push
    into a repository watched by the assistant auto-merge.
  * Makefile: Install completions for the fish and zsh shells
    when git-annex is built with optparse-applicative-0.14.
  * assistant: Don't trust OSX FSEvents's eventFlagItemModified to be called
    when the last writer of a file closes it; apparently that sometimes
    does not happen, which prevented files from being quickly added.

 -- Joey Hess <id@joeyh.name>  Mon, 12 Jun 2017 13:37:16 -0400

git-annex (6.20170519) unstable; urgency=medium

  * Ssh password prompting improved when using -J for concurrency.
    When ssh connection caching is enabled (and when GIT_ANNEX_USE_GIT_SSH
    is not set), only one ssh password prompt will be made per host, and
    only one ssh password prompt will be made at a time.
  * When built with concurrent-output 1.9, ssh password prompts will no
    longer interfere with the -J display.
  * Removed dependency on MissingH, instead depending on the split library.
  * Progress is displayed for transfers of files of unknown size.
  * Work around bug in git 2.13.0 involving GIT_COMMON_DIR that broke
    merging changes into adjusted branches.

 -- Joey Hess <id@joeyh.name>  Fri, 19 May 2017 10:37:57 -0400

git-annex (6.20170510) unstable; urgency=medium

  * When a http remote does not expose an annex.uuid config, only warn
    about it once, not every time git-annex is run.
  * multicast: New command, uses uftp to multicast annexed files, for eg
    a classroom setting.
  * Added remote.<name>.annex-push and remote.<name>.annex-pull
    which can be useful to make remotes that don't get fully synced with
    local changes.
  * Disable git-annex's support for GIT_SSH and GIT_SSH_COMMAND, unless
    GIT_ANNEX_USE_GIT_SSH=1 is also set in the environment. This is
    necessary because as feared, the extra -n parameter that git-annex
    passes breaks uses of these environment variables that expect exactly
    the parameters that git passes.
